include 'network.inc'

SNDBUFFER	= 4096
RCVBUFFER	= 4096


proc resolve_dns url:DWORD
; Resolve DNS string into IP
; Inputs:
;       url - pointer to URL string buffer
; Outputs:
;       eax - error code (0 if ok)
;       ebx - IP address pointer

	inc	[status]	; Set STATUS_RESOLVING
	push	esp		; Reserve stack place
	push	esp		; ptr to result
	push	0		; addrinfo hints
	push	0		; servname
	push	[url]		; hostname
	call	[getaddrinfo]	; Resolve name
	pop	ebx
	ret
endp

proc open_socket
; Open
	inc	[status]		; set STATUS_CONNECTING
	mcall	socket, AF_INET4, SOCK_STREAM, 0
	cmp	eax, -1
	jz	.fail
	mov	[socketnum], eax
; Connect
	mcall	connect, [socketnum], sockaddr1, 18
	cmp	eax, -1
	jz	.fail

	inc	[status]
	ret

 .fail:
	mov	[status], 0
	ret
endp

proc convert_IP_dec addr:DWORD
; Convert IP address to decimal notation
; Inputs:
;       addr - pointer to address returned by getaddrinfo
; Outputs:
;       eax - pointer to string buffer with decimal IP

	mov	eax, [addr]
	add	eax, addrinfo.ai_addr
	mov	eax, [eax]
	mov	eax, [eax+sockaddr_in.sin_addr]
	mov	[sockaddr1.ip], eax
	push	eax
	call	[inet_ntoa]
	mov	[ip_ptr], eax
	ret
endp

proc socket_recieve
	stdcall cleanbuf,[rcv_buffer],RCVBUFFER
;        mcall   recv, [socketnum], rcv_buffer, RCVBUFFER, MSG_DONTWAIT
	mcall	recv, [socketnum], [rcv_buffer], RCVBUFFER, 0
	ret
endp
