proc addXmlAttr buffer,node,attrName,attrValue
	push edi
	push ecx
	push ebx
	push eax

	mov edi, [buffer]

	push [attrName]
	call isEmpty
	jc addXmlAttr_error

	mov eax, ecx

	push [node]
	call isEmpty
	jc addXmlAttr_error

	push 0
	push ecx
	push [node]
	call findOpenTagClosing
	jc addXmlAttr_error

	mov ebx, ecx

	push ecx
	push [node]
	call putStr

	call putSpace

	push eax
	push [attrName]
	call putStr

	call putEqual

	call putDoubleQuote

	push [attrValue]
	call getStrLen
	push ecx
	push [attrValue]
	call putStr

	call putDoubleQuote

	push [node]
	call getStrLen
	sub ecx, ebx
	push ecx
	add ebx, [node]
	push ebx
	call putStr
	jmp addXmlAttr_exit

addXmlAttr_error:
	stc

addXmlAttr_exit:
	pop eax
	pop ebx
	pop ecx
	pop edi
	ret
endp

proc deleteXmlAttr buffer,node,attrName
	push edi
	push esi
	push edx
	push ecx
	push ebx
	push eax

	mov edi, [buffer]

	push [attrName]
	call isEmpty
	jc deleteXmlAttr_exit

	mov eax, ecx

	push [node]
	call isEmpty
	jc deleteXmlAttr_exit

	push 0
	push ecx
	push [node]
	call findOpenTagClosing
	jc deleteXmlAttr_exit

	mov edx, ecx

	mov esi, 0
deleteXmlAttr_scan:
	push esi
	push edx
	push [node]
	call findSpace
	jc deleteXmlAttr_exit

	add esi, ecx
	add esi, 1

	mov ebx, esi
	add ebx, [node]

	push eax
	push [attrName]
	push ebx
	call compareAttrName
	jc deleteXmlAttr_scan

	pop esi

	sub ebx, [node]

	sub edx, ebx

	push ebx
	push edx
	push [node]
	call findNextQuote
	jc deleteXmlAttr_exit

	add ecx, ebx
	add ecx, 1
	mov eax, ecx

	push eax
	push edx
	push [node]
	call findNextQuote
	jc deleteXmlAttr_exit

	add eax, ecx
	add eax, 1

	sub ebx, 1
	push ebx
	push [node]
	call putStr

	push [node]
	call getStrLen
	sub ecx, eax
	push ecx
	add eax, [node]
	push eax
	call putStr

	call endNode

deleteXmlAttr_exit:
	pop eax
	pop ebx
	pop ecx
	pop edx
	pop esi
	pop edi
	ret
endp

proc renameXmlAttr buffer,node,attrName,newName
	push edi
	push esi
	push edx
	push ecx
	push ebx
	push eax

	mov edi, [buffer]

	push [newName]
	call isEmpty
	jc renameXmlAttr_exit

	push [attrName]
	call isEmpty
	jc renameXmlAttr_exit

	mov eax, ecx

	push [node]
	call isEmpty
	jc renameXmlAttr_exit

	push 0
	push ecx
	push [node]
	call findOpenTagClosing
	jc renameXmlAttr_exit

	mov edx, ecx

	mov esi, 0
renameXmlAttr_scan:
	push esi
	push edx
	push [node]
	call findSpace
	jc renameXmlAttr_exit

	add esi, ecx
	add esi, 1

	mov ebx, esi
	add ebx, [node]

	push eax
	push [attrName]
	push ebx
	call compareAttrName
	jc renameXmlAttr_scan

	pop esi

	sub ebx, [node]

	sub edx, ebx

	push ebx
	push edx
	push [node]
	call findSpaceOrEqual
	jc renameXmlAttr_exit

	add ecx, ebx
	sub ecx, 1
	mov eax, ecx
	add eax, 1

	push ebx
	push [node]
	call putStr

	push [newName]
	call getStrLen
	push ecx
	push [newName]
	call putStr

	push [node]
	call getStrLen
	sub ecx, eax
	push ecx
	add eax, [node]
	push eax
	call putStr

	call endNode

renameXmlAttr_exit:
	pop eax
	pop ebx
	pop ecx
	pop edx
	pop esi
	pop edi
	ret
endp

proc getXmlAttrValue buffer,node,attrName
	pusha

	mov edi, [buffer]

	stdcall isEmpty,[attrName]
	jc getXmlAttrValue_exit

	mov eax, ecx

	stdcall isEmpty,[node]
	jc getXmlAttrValue_exit

	stdcall findOpenTagClosing,[node],ecx,0
	jc getXmlAttrValue_exit

	mov edx, ecx

	mov esi, 0
getXmlAttrValue_scan:
	stdcall findSpace,[node],edx,esi
	jc getXmlAttrValue_exit

	add esi, ecx
	add esi, 1

	mov ebx, esi
	add ebx, [node]

	stdcall compareAttrName,ebx,[attrName],eax
	jc getXmlAttrValue_scan

;        pop esi

	sub ebx, [node]

	sub edx, ebx

	stdcall findNextQuote,[node],edx,ebx
	jc getXmlAttrValue_exit

	add ecx, ebx
	add ecx, 1
	mov eax, ecx

	push eax
	push edx
	push [node]
	call findNextQuote
	jc getXmlAttrValue_exit

	add eax, [node]

	push ecx
	push eax
	call putStr

	call endNode

getXmlAttrValue_exit:
	popa
	ret
endp

proc setXmlAttrValue buffer,node,attrName,newValue
	push edi
	push esi
	push edx
	push ecx
	push ebx
	push eax

	mov edi, [buffer]

	push [attrName]
	call isEmpty
	jc setXmlAttrValue_exit

	mov eax, ecx

	push [node]
	call isEmpty
	jc setXmlAttrValue_exit

	push 0
	push ecx
	push [node]
	call findOpenTagClosing
	jc setXmlAttrValue_exit

	mov edx, ecx

	mov esi, 0
setXmlAttrValue_scan:
	push esi
	push edx
	push [node]
	call findSpace
	jc setXmlAttrValue_exit

	add esi, ecx
	add esi, 1

	mov ebx, esi
	add ebx, [node]

	push eax
	push [attrName]
	push ebx
	call compareAttrName
	jc setXmlAttrValue_scan

	pop esi

	sub ebx, [node]

	sub edx, ebx

	push ebx
	push edx
	push [node]
	call findNextQuote
	jc setXmlAttrValue_exit

	add ecx, ebx
	add ecx, 1
	mov eax, ecx

	push eax
	push edx
	push [node]
	call findNextQuote
	jc setXmlAttrValue_exit

	mov edx, eax
	add edx, ecx

	push eax
	push [node]
	call putStr

	push [newValue]
	call getStrLen
	push ecx
	push [newValue]
	call putStr

	push [node]
	call getStrLen
	sub ecx, edx
	push ecx
	add edx, [node]
	push edx
	call putStr

	call endNode

setXmlAttrValue_exit:
	pop eax
	pop ebx
	pop ecx
	pop edx
	pop esi
	pop edi
	ret
endp
