proc newXmlNodeOpening buffer,nodeName
	push edi
	push ecx

	mov edi, [buffer]

	push [nodeName]
	call isEmpty
	jc newXmlNode_exit

	call openTag

	push ecx
	push [nodeName]
	call putStr

	call closeTag
	call endNode

	pop ecx
	pop edi
	ret
endp

proc newXmlNodeClosing buffer,nodeName
	push edi
	push ecx

	mov edi, [buffer]

	push [nodeName]
	call isEmpty
	jc newXmlNode_exit

	call openCloseTag

	push ecx
	push [nodeName]
	call putStr

	call closeTag
	call endNode

	pop ecx
	pop edi
	ret
endp

proc newXmlNode buffer,nodeName,nodeValue
	push edi
	push ecx

	mov edi, [buffer]

	push [nodeName]
	call isEmpty
	jc newXmlNode_exit

	call openTag

	push ecx
	push [nodeName]
	call putStr

	push [nodeValue]
	call isEmpty
	jc newXmlNode_closeSingle

	call closeTag

	push [nodeValue]
	call getStrLen
	push ecx
	push [nodeValue]
	call putStr

	call openCloseTag

	push [nodeName]
	call getStrLen
	push ecx
	push [nodeName]
	call putStr

	call closeTag
	call endNode
	jmp newXmlNode_exit

newXmlNode_closeSingle:
	call closeSingleTag
	call endNode
	jmp newXmlNode_exit

newXmlNode_exit:
	pop ecx
	pop edi
	ret
endp

proc getXmlNodeValue buffer,node
	push edi
	push ecx
	push eax

	mov edi, [buffer]

	push [node]
	call isEmpty
	jc getXmlNodeValue_exit

	push 0
	push ecx
	push [node]
	call findOpenTagClosing
	jc getXmlNodeValue_exit

	mov eax, ecx
	add eax, 1

	push [node]
	call getStrLen

	push ecx
	push [node]
	call findLastCloseTagOpening
	jc getXmlNodeValue_exit

	cmp ecx, eax
	jb getXmlNodeValue_exit

	sub ecx, eax
	push ecx
	add eax, [node]
	push eax
	call putStr

getXmlNodeValue_exit:
	pop eax
	pop ecx
	pop edi
	ret
endp

proc setXmlNodeValue buffer,node,newValue
	push edi
	push ecx
	push eax

	mov edi, [buffer]

	push [node]
	call isEmpty
	jc setXmlNodeValue_exit

	push 0
	push ecx
	push [node]
	call findOpenTagClosing
	jc setXmlNodeValue_exit

	add ecx, 1
	push ecx
	push [node]
	call putStr
 
	push [newValue]
	call getStrLen
	push ecx
	push [newValue]
	call putStr

	push [node]
	call getStrLen
	push ecx
	push [node]
	call findLastCloseTagOpening
	jc setXmlNodeValue_exit

	mov eax, ecx

	push [node]
	call getStrLen
	push ecx
	add eax, [node]
	push eax
	call putStr

setXmlNodeValue_exit:
	pop eax
	pop ecx
	pop edi
	ret
endp

proc getXmlNodeName buffer,node
	push edi
	push ecx
	push eax

	mov edi, [buffer]

	push [node]
	call isEmpty
	jc getXmlNodeName_exit

	push ecx
	push [node]
	call findOpenTagOpening
	jc getXmlNodeName_exit
	
	mov eax, ecx
	add eax, 1
	
	push [node]
	call getStrLen
	push eax
	push ecx
	push [node]
	call findSpaceOrTagClosing
	jc getXmlNodeName_exit
	
	cmp ecx, eax
	jb getXmlNodeName_exit
	
	sub ecx, eax
	sub ecx, 1
	push ecx
	add eax, [node]
	push eax
	call putStr
	
getXmlNodeName_exit:
	pop eax
	pop ecx
	pop edi
	ret
endp

proc setXmlNodeName buffer,node,newName
	push edi
	push ecx
	push eax

	mov edi, [buffer]

	push [node]
	call isEmpty
	jc setXmlNodeName_exit

	push 0
	push ecx
	push [node]
	call findSpaceOrTagClosing
	jc setXmlNodeName_exit
	
	mov eax, ecx
	
	call openTag

	push [newName]
	call getStrLen
	push ecx
	push [newName]
	call putStr
	
	push [node]
	call getStrLen
	push ecx
	push [node]
	call findLastCloseTagOpening
	jc setXmlNodeName_exit

	sub ecx, eax
	push ecx
	add eax, [node]
	push eax
	call putStr
	
	call openCloseTag

	push [newName]
	call getStrLen
	push ecx
	push [newName]
	call putStr

	call closeTag
	call endNode
	
setXmlNodeName_exit:
	pop eax
	pop ecx
	pop edi
	ret
endp

proc addXmlChildNode buffer,node,childNode
	push edi
	push ecx
	push ebx
	push eax

	mov edi, [buffer]

	push [childNode]
	call isEmpty
	jc addXmlChildNode_exit
	
	mov eax, ecx
	
	push [node]
	call isEmpty
	jc addXmlChildNode_exit

	push ecx
	push [node]
	call findLastCloseTagOpening
	jc addXmlChildNode_exit	

	mov ebx, ecx

	push ecx
	push [node]
	call putStr

	push eax
	push [childNode]
	call putStr
	
	push ebx
	add ebx, [node]
	push ebx
	call putStr
	call endNode

addXmlChildNode_exit:
	pop eax
	pop ebx
	pop ecx
	pop edi
	ret
endp
