proc getStrLen string
	push esi
	push edx

	mov esi, [string]
	mov ecx, 0
	sub ecx, 1
getStrLen_scan:
	add ecx, 1
	mov dl, byte [esi]
	add esi, 1
	cmp dl, 0
	jnz getStrLen_scan

	pop edx
	pop esi
	ret
endp

proc isEmpty string
	push [string]
	call getStrLen
	cmp ecx, 0
	jz isEmpty_error
	ret
isEmpty_error:
	stc
	ret
endp

proc findNextQuote string,strLen,strPos
	push esi
	push edx
	push eax

	mov eax, [strLen]
	mov esi, [string]
	add esi, [strPos]
	mov ecx, 0
	sub ecx, 1
findNextQuote_scan:
	add ecx, 1
	mov dl, byte [esi]
	add esi, 1
	cmp eax, ecx
	jz findNextQuote_failed
	cmp dl, """"
	jz  findNextQuote_exit
	cmp dl, 39
	jz  findNextQuote_exit
	jmp findNextQuote_scan

findNextQuote_failed:
	stc

findNextQuote_exit:
	pop eax
	pop edx
	pop esi
	ret
endp

proc findSpace string,strLen,strPos
	push esi
	push edx
	push eax

	mov eax, [strLen]
	mov esi, [string]
	add esi, [strPos]
	mov ecx, 0
	sub ecx, 1
findSpace_scan:
	add ecx, 1
	mov dl, byte [esi]
	add esi, 1
	cmp eax, ecx
	jz findSpace_failed
	cmp dl, " "
	jnz findSpace_scan
	jmp findSpace_exit

findSpace_failed:
	stc

findSpace_exit:
	pop eax
	pop edx
	pop esi
	ret
endp

proc findSpaceOrEqual string,strLen,strPos
	push esi
	push edx
	push eax

	mov eax, [strLen]
	mov esi, [string]
	add esi, [strPos]
	mov ecx, 0
	sub ecx, 1
findSpaceOrEqual_scan:
	add ecx, 1
	mov dl, byte [esi]
	add esi, 1
	cmp eax, ecx
	jz findSpaceOrEqual_failed
	cmp dl, " "
	jz findSpaceOrEqual_exit
	cmp dl, "="
	jnz findSpaceOrEqual_scan
	jmp findSpaceOrEqual_exit

findSpaceOrEqual_failed:
	stc

findSpaceOrEqual_exit:
	pop eax
	pop edx
	pop esi
	ret
endp

proc findSpaceOrTagClosing string,strLen,strPos
	push esi
	push edx
	push eax

	mov eax, [strLen]
	mov esi, [string]
	mov ecx, [strPos]
;        sub ecx, 1
findSpaceOrTagClosing_scan:
	add ecx, 1
	mov dl, byte [esi+1]
	add esi, 1
	cmp eax, ecx
	jz findSpaceOrTagClosing_failed
	cmp ecx, 0
	jz findSpaceOrTagClosing_skip
	cmp dl, "<"
	jz findSpaceOrTagClosing_failed
findSpaceOrTagClosing_skip:
	cmp dl, " "
	jz findSpaceOrTagClosing_exit
	cmp dl, "/"
	jz findSpaceOrTagClosing_exit
	cmp dl, ">"
	jnz findSpaceOrTagClosing_scan
	jmp findSpaceOrTagClosing_exit

findSpaceOrTagClosing_failed:
	stc

findSpaceOrTagClosing_exit:
	pop eax
	pop edx
	pop esi
	ret
endp

; Finds first closing tag (> symbol) from the given position
; If finds < or byte 0 - returns fail
; Returns string length in eax
; Returns the position of the symbol in ecx
; Don't forget to inc ecx if you need the position AFTER >
proc findOpenTagClosing string,strLen,strPos
	push esi
	push edx
	push eax

	mov eax, [strLen]
	mov esi, [string]
	mov ecx, [strPos]
	sub ecx, 1
findOpenTagClosing_scan:
	add ecx, 1
	mov dl, byte [esi]
	add esi, 1
	cmp eax, ecx
	jz findOpenTagClosing_failed
	cmp ecx, 0
	jz findOpenTagClosing_skip
	cmp dl, "<"
	jz findOpenTagClosing_failed
findOpenTagClosing_skip:
	cmp dl, "/"
	jz findOpenTagClosing_slash
	cmp dl, ">"
	jnz findOpenTagClosing_scan
	jmp findOpenTagClosing_exit

findOpenTagClosing_slash:
	mov dl, byte [esi+1]
	cmp dl, ">"
	jnz findOpenTagClosing_scan
	jmp findOpenTagClosing_exit

findOpenTagClosing_failed:
	stc

findOpenTagClosing_exit:
	pop eax
	pop edx
	pop esi
	ret
endp

proc findOpenTagOpening string,strLen
	push esi
	push edx
	push eax

	mov eax, [strLen]
	mov esi, [string]
	mov ecx, 0
	sub ecx, 1
findOpenTagOpening_scan:
	add ecx, 1
	mov dl, byte [esi]
	add esi, 1
	cmp eax, ecx
	jz findOpenTagOpening_failed
	cmp dl, "<"
	jnz findOpenTagOpening_scan
	jmp findOpenTagOpening_exit

findOpenTagOpening_failed:
	stc

findOpenTagOpening_exit:
	pop eax
	pop edx
	pop esi
	ret
endp

proc findLastCloseTagOpening string,strLen
	push esi
	push edx
	push eax

	mov eax, [strLen]
	mov esi, [string]
	add esi, eax
	sub esi, 1
	sub esi, 1
	mov ecx, 0
	sub ecx, 1
findLastCloseTagOpening_scan:
	add ecx, 1
	mov dx, word [esi]
	sub esi, 1
	cmp eax, ecx
	jz findLastCloseTagOpening_failed
	cmp dx, "</"
	jnz findLastCloseTagOpening_scan
	sub eax, ecx
	mov ecx, eax
	sub ecx, 1
	sub ecx, 1
	jmp findLastCloseTagOpening_exit

findLastCloseTagOpening_failed:
	stc

findLastCloseTagOpening_exit:
	pop eax
	pop edx
	pop esi
	ret
endp

proc compareAttrName nodeString,attrName,attrNameSize
	push edi
	push esi
	push edx
	push ebx
	push eax

	mov edi, [nodeString]
	mov esi, [attrName]
	mov ecx, [attrNameSize]
compareAttrName_scan:
	mov dl, byte [esi]
	mov bl, byte [edi]
	add esi, 1
	add edi, 1
	cmp bl, dl
	jnz compareAttrName_failed
	sub ecx, 1
	jnz compareAttrName_scan
	mov bl, byte [edi]
	cmp bl, "="
	jz compareAttrName_exit
	cmp bl, " "
	jz compareAttrName_exit

compareAttrName_failed:
	stc

compareAttrName_exit:
	pop eax
	pop ebx
	pop edx
	pop esi
	pop edi
	ret
endp
