proc parseXml lpBuf:DWORD,lpLen:DWORD
	stdcall getTagCount,[lpBuf]
	; Allocate mem for nodes = ecx*256
	shl	ecx,8
	mcall	68,12,ecx
	; Set pointer to the beginning of the buffer
	mov	edi,lpBuf

	; Scan for next XML event
     .scan:
	cmp	[edi],'<'
	je	.opening

	cmp	[edi],'>'
	je	.closing

	cmp	edi,lpBuf+lpLen
	je	.final

	inc	edi
	jmp	.scan

     .opening:
	mov	XML_STATE, 01b
	inc	edi
	jmp	.scan

     .closing:
	cmp	XML_STATE, 01b
	je	.closing.value

     .final:
	ret
endp

proc getTagCount,lpBuf,lpLen
	push eax,ebx,edx,esi,edi
	mov	ecx,[lpLen]
	mov	ax,ds
	mov	es,ax
	cld
	mov	al,'<'
	mov	ebx,0
     @@:
	; Search for every <
	repne	scasb
	je	.opening
	jmp	.final
     .opening:
	inc	ebx
	jmp	@b
     .final:
	; Divide by 2 since we'll have both openings and closings
	shr	ebx,1
	mov	ecx,ebx
	pop	edi,esi,edx,ebx,eax
	ret
endp

struct NODE
	.name		rb 127
	.value		rb 127
	.first_attr	db ?
	.next_node	db ?
ends

struct ATTR
	.name		rb 127
	.value		rb 127
	.next_attr	db ?
ends

; State indicator
; 00 - unknown
; 01 - inside XML node
; 10 - inside XML value
XML_STATE	db 0b