
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; GUI Constants
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
login_win_X	= 300
login_win_Y	= 450
SNDBUFFER	= 4096
RCVBUFFER	= 4096
BTN_X		= 10*65536 + 280
BTN_Y		= 125*65536 + 20
eb_width	= 200
eb_left 	= (login_win_X-eb_width)/2
eb_bg		= 0xffffff
eb_shift	= 0x6f9480
eb_focus	= 0
eb_blur 	= 0xAABBCC
eb_text_col	= 0
eb_tmax 	= 45

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; MAIN
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

proc wait_login
	mcall	10
	cmp	eax, 1
	je	.redraw

	cmp	eax, 2
	je	.key

	cmp	eax, 3
	je	.button

	cmp	eax, 6
	je	.mouse

	cmp	eax, 8
	je	.network

	jmp	.final

     .redraw:
	call	login_win_draw
	jmp	.final

     .key:
	call	login_key
	jmp	.final

     .button:
	call	login_btn_action
	jmp	.final

     .mouse:
	; Check login box
	invoke	edit_box_mouse, login_box
	; Check password box
	invoke	edit_box_mouse, pass_box
	; Check server box
	invoke	edit_box_mouse, serv_box
	; Check ip box
	invoke	edit_box_mouse, ip_box
	jmp	.final

     .network:
	call	socket_recieve
	call	parse_login
	jmp	.final

     .final:
	ret
endp

;<<<<<<<<<<<<<<<<<<<<<<<
; GUI ACTIONS
;<<<<<<<<<<<<<<<<<<<<<<<

proc login_win_draw
	; Start redraw
	mcall	12, 1
	; fn 0 - define and draw window
	mov	eax, 0
	; fn 0.ebx - win X dims
	mov	ebx, 100	; Upper left X
	shl	ebx, 16
	add	ebx, login_win_X; Size
	; fn 0.ecx - win Y dims
	mov	ecx, 100	; Upper left Y
	shl	ecx, 16
	add	ecx, login_win_Y; Size
	; fn 0.edx - window colour and type (type 14 - fixed size with title)
	mov	edx, [sc.work]
	or	edx, 0x14000000
	; fn 0.esi - window title style and colour
	mov	esi, [sc.grab]
	or	esi, 0x80000000
	mcall
	; Draw login box
	invoke	edit_box_draw, login_box
	; Draw pass box
	invoke	edit_box_draw, pass_box
	; Draw server box
	invoke	edit_box_draw, serv_box
	; Draw ip box
	invoke	edit_box_draw, ip_box
	; Draw ok btn
	mcall	8,BTN_X,BTN_Y,0x2,0x00aaaaaa
	; End redraw
	mcall	12,2
	; Return
	ret
endp

; Key was pressed
proc login_key
	; Recieve pressed key into eax
	mcall	2
	; Add value into loginbox if it was editbox key
	invoke	edit_box_key, login_box
	; Add value into passbox if it was editbox key
	invoke	edit_box_key, pass_box
	; Add value into servbox if it was editbox key
	invoke	edit_box_key, serv_box
	; Wait for next input
	ret
endp

; Button was pressed
proc login_btn_action
	; Get button number
	mcall	17
	; If id = 1 (red cross) - close program
	cmp	ah, 1
	je	close_progr
	; If id = 2 - login button
	cmp	ah, 2
	je	login_submit
	; Wait for next input
	ret
endp

proc login_submit
	construct_stream	x_stream,login_text,serv_text
; DNS
	stdcall resolve_dns,ip_text
	test	eax,eax 	; Test for error
	jnz	.final

; Open socket
	stdcall convert_IP_dec,ebx  ; If no error - get decimal IP
	mov	[sockaddr1.port], 0x6614
	call	open_socket
	cmp	eax, -1
	je	.final

; Construct and send xml
	stdcall strcpy,xc_xml_start,[snd_buffer]
	ccall createXmlOpen,xc_stream,xc_stream,edi, \
		xc_nsstr, x_stream+vstream.nsstr, \
		xc_ns, x_stream+vstream.ns,\
		xc_lang, x_stream+vstream.lang,\
		xc_version, x_stream+vstream.version,\
		xc_to, x_stream+vstream.to,\
		xc_from, x_stream+vstream.from,\
		0
	sub	esp, 0xC

	stdcall strlen,[snd_buffer]
	mov	[msg_len], ecx
	mcall	send, [socketnum], [snd_buffer], [msg_len], 0

     .final:
	ret
endp

proc parse_login
	cmp	[status],STATUS_CONNECTED
	je	.connected
	cmp	[status],STATUS_LOGIN
	je	.logged_in
	jmp	.final

     .connected:
	stdcall auth_logic
	jmp	.final

     .logged_in:
	stdcall session_logic
	jmp	.final

     .final:
	ret
endp

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; NET ACTIONS
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
proc auth_plain
; Pushing auth xml parameters
	ccall createXmlOpen,xc_auth,'',[snd_buffer],\
		xc_ns, xc_auth_ns,\
		xc_auth_mech, xc_auth_plain,\
		0
	sub	esp, 0xC

; Creating Base64 \0user0\pass
	; Get username length without domain
	mov	ebx,edi
	stdcall strstr,x_stream.from,128,xc_at,1
	mov	edi,tmp_string
	mov	[edi],byte 0
	inc	edi
	; Copy it into buffer
	stdcall strcpy_l,x_stream.from,edi,eax
	mov	[edi],byte 0
	inc	edi
	; Copy password
	stdcall strcpy,pass_text,edi
	; Get length
	mov	ecx, edi
	sub	ecx, tmp_string
	; Encode
	stdcall base64_encode,tmp_string,ecx,ebx
	stdcall strlen,[snd_buffer]
	add	ecx,[snd_buffer]
	stdcall createXmlClose,xc_auth,'',ecx
; Sending
	stdcall strlen,[snd_buffer]
	mov	[msg_len], ecx
	ret
endp

proc auth_md5
	; Request MD5 handshake
	ccall createXmlShort,xc_auth,'',[snd_buffer],\
		xc_ns, xc_auth_ns,\
		xc_auth_mech, xc_auth_md5,\
		0
	sub	esp,0xC

	stdcall strlen,[snd_buffer]
	mov	[msg_len], ecx
	mcall	send, [socketnum], [snd_buffer], [msg_len], 0

	;
endp

proc bind_res
	ccall createXmlOpen,xc_iq,'',[snd_buffer],\
		xc_type, xc_iq_type_set,\
		xc_id, xc_bind,\
		0
	sub	esp, 0xC

	stdcall strlen,[snd_buffer]
	add	ecx,[snd_buffer]
	ccall createXmlShort,xc_bind,'',ecx,\
		xc_ns, xc_bind_ns,\
		0
	sub	esp, 0xC

	stdcall strlen,[snd_buffer]
	add	ecx,[snd_buffer]
	stdcall createXmlClose,xc_iq,'',ecx

	stdcall strlen,[snd_buffer]
	mov	[msg_len], ecx
	ret
endp

proc new_session
	ccall createXmlOpen,xc_iq,'',[snd_buffer],\
		xc_to, x_stream.to,\
		xc_type, xc_iq_type_set,\
		xc_id, xc_session,\
		0
	sub	esp, 0xC

	stdcall strlen,[snd_buffer]
	add	ecx,[snd_buffer]
	ccall createXmlShort,xc_session,'',ecx,\
		xc_ns, xc_session_ns,\
		0
	sub	esp, 0xC

	stdcall strlen,[snd_buffer]
	add	ecx,[snd_buffer]
	stdcall createXmlClose,xc_iq,'',ecx

	stdcall strlen,[snd_buffer]
	mov	[msg_len], ecx

	ret
endp

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; LOGIC
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Authentication step logic
proc auth_logic
     .stream:
	stdcall strlen,xc_stream
	stdcall strstr,[rcv_buffer],RCVBUFFER,xc_stream,ecx
	test	eax,eax
	jz	@f

     .features:
	stdcall strlen,xc_features
	stdcall strstr,[rcv_buffer],RCVBUFFER,xc_features,ecx
	test	eax,eax
	jz	@f

     .auth_mech:
	stdcall strlen,xc_auth_mech
	stdcall strstr,[rcv_buffer],RCVBUFFER,xc_auth_mech,ecx
	test	eax,eax
	jz	@f
	stdcall auth_plain
	mcall	send, [socketnum], [snd_buffer], [msg_len],0
	jmp	.final

@@:
     .auth_success:
	stdcall strlen,xc_success
	stdcall strstr,[rcv_buffer],RCVBUFFER,xc_success,ecx
	test	eax,eax
	jz	@f
	inc	[status]
	stdcall session_logic
	jmp	.final

@@:
     .final:
	ret
endp


; Session init logic
proc session_logic
     .auth_success:
	stdcall strlen,xc_success
	stdcall strstr,[rcv_buffer],RCVBUFFER,xc_success,ecx
	test	eax,eax
	jz	.stream
	; Construct XML stream query
	construct_stream	x_stream,login_text,serv_text
	stdcall strcpy,xc_xml_start,[snd_buffer]
	ccall createXmlOpen,xc_stream,xc_stream,edi,\
		xc_nsstr, x_stream+vstream.nsstr, \
		xc_ns, x_stream+vstream.ns,\
		xc_lang, x_stream+vstream.lang,\
		xc_version, x_stream+vstream.version,\
		xc_to, x_stream+vstream.to,\
		xc_from, x_stream+vstream.from,\
		0
	sub	esp, 0xC
	; Send query
	stdcall strlen,[snd_buffer]
	mov	[msg_len], ecx
	mcall	send, [socketnum], [snd_buffer], [msg_len], 0
	jmp	.final

@@:
     .stream:
	stdcall strlen,xc_stream
	stdcall strstr,[rcv_buffer],RCVBUFFER,xc_stream,ecx
	test	eax,eax
	jz	@f
     .features:
	stdcall strlen,xc_features
	stdcall strstr,[rcv_buffer],RCVBUFFER,xc_features,ecx
	test	eax,eax
	jz	@f

     .bind_and_session:
	stdcall bind_res
	mcall	send, [socketnum], [snd_buffer], [msg_len],0
	stdcall new_session
	mcall	send, [socketnum], [snd_buffer], [msg_len],0
	inc	[status]
	stdcall request_roster
	jmp	.final

@@:
     .final:
	ret
endp


;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; DATA
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;-----------------------------------
login_top	= 25
login_text	db 'test1@test.com',0
login_end:
	rb 256
login_box	edit_box	eb_width, eb_left, login_top,\	; Width, left, top
				eb_bg, eb_shift, eb_focus,\	; bg color, shift color, focus color
				eb_blur, eb_text_col, eb_tmax,\ ; blur color, text color, max text
				login_text, 0, ed_focus,\	; text, mouse_var, flags
				login_end - login_text - 1,\	; size
				login_end - login_text - 1	; pos
;-----------------------------------
pass_top	= 50
pass_text	db 'test',0
pass_end:
	rb 256
pass_box	edit_box	eb_width, eb_left, pass_top,\	; Width, left, top
				eb_bg, eb_shift, eb_focus,\	; bg color, shift color, focus color
				eb_blur, eb_text_col, eb_tmax,\ ; blur color, text color, max text
				pass_text, 0, ed_pass,\ 	; text, mouse_var, flags
				pass_end - pass_text - 1,\	; size
				pass_end - pass_text - 1	; pos
;-----------------------------------
serv_top	= 75
serv_text	db 'test.com',0
serv_end:
	rb 256
serv_box	edit_box	eb_width, eb_left, serv_top,\	; Width, left, top
				eb_bg, eb_shift, eb_focus,\	; bg color, shift color, focus color
				eb_blur, eb_text_col, eb_tmax,\ ; blur color, text color, max text
				serv_text, 0, 0,\		; text, mouse_var, flags
				serv_end - serv_text - 1,\	; size
				serv_end - serv_text - 1	; pos

ip_top		= 100
ip_text 	db '10.0.2.15',0
ip_end:
	rb 256
ip_box		edit_box	eb_width, eb_left, ip_top,\   ; Width, left, top
				eb_bg, eb_shift, eb_focus,\	; bg color, shift color, focus color
				eb_blur, eb_text_col, eb_tmax,\ ; blur color, text color, max text
				ip_text, 0, 0,\ 	      ; text, mouse_var, flags
				ip_end - ip_text - 1,\	    ; size
				ip_end - ip_text - 1	    ; pos


tmp_string     rb 256