;<<<<<<<<<<<<<<<<<<<<<<<<
; CONSTANTS
;<<<<<<<<<<<<<<<<<<<<<<<<

main_win_X	= 300
main_win_Y	= 450
ICON_SIZE	= 3*200*100


;<<<<<<<<<<<<<<<<<<<<<<<<
; WINDOW
;<<<<<<<<<<<<<<<<<<<<<<<<
align 4
proc init_tree_list
	stdcall dword[tl_data_init], dword main_tree
	; Add node images
	stdcall mem.Alloc,dword ICON_SIZE
	mov	[arrow_icon],eax
	; Obtain full path
	copy_path	arrow_icon_fn,sys_path,file_name,0
	; Open icon file
	mov	eax,70
	mov	[run_file_70.Function],0
	mov	[run_file_70.Position],0
	mov	[run_file_70.Flags],0
	mov	[run_file_70.Count],DWORD ICON_SIZE
	m2m	[run_file_70.Buffer], [arrow_icon]
	mov	byte[run_file_70+20],0
	mov	[run_file_70.FileName], file_name
	mov	ebx,run_file_70
	int	0x40
	cmp	ebx,0xffffffff
	je	@f
	; Check image type and put it into the temp buffer
	stdcall dword[img_decode], dword[arrow_icon], ebx, 0
	mov	dword[temp_icon],eax
	; Convert to RGB
	stdcall dword[img_to_rgb2], dword[temp_icon], dword[arrow_icon]
	stdcall dword[img_destroy], dword[temp_icon]
	; Assign image as icon
	m2m	dword[main_tree.data_img_sys],dword[arrow_icon]


     @@:
	; Add node images
	stdcall mem.Alloc,dword ICON_SIZE
	mov	[node_icon],eax
	; Obtain full path
	copy_path	node_icon_fn,sys_path,file_name,0
	; Open icon file
	mov	eax,70
	mov	[run_file_70.Function],0
	mov	[run_file_70.Position],0
	mov	[run_file_70.Flags],0
	mov	[run_file_70.Count],DWORD ICON_SIZE
	m2m	[run_file_70.Buffer], [node_icon]
	mov	byte[run_file_70+20],0
	mov	[run_file_70.FileName], file_name
	mov	ebx,run_file_70
	int	0x40
	cmp	ebx,0xffffffff
	je	@f
	; Check image type and put it into the temp buffer
	stdcall dword[img_decode], dword[node_icon], ebx, 0
	mov	dword[temp_icon],eax
	; Convert to RGB
	stdcall dword[img_to_rgb2], dword[temp_icon], dword[node_icon]
	stdcall dword[img_destroy], dword[temp_icon]
	; Assign image as icon
	m2m	dword[main_tree.data_img],dword[node_icon]

     @@:
	ret
endp

proc main_win_draw
	; Start redraw
	mcall	12, 1
	; Get sys colours into sys_colors var
	call	get_sys_colors
	; fn 0 - define and draw window
	mov	eax, 0
	; fn 0.ebx - win X dims = start * 65536 + x_size
	mov	ebx, 100	; Upper left X
	shl	ebx, 16
	add	ebx, login_win_X; Size
	; fn 0.ecx - win Y dims = start * 65536 + y_size
	mov	ecx, 100	; Upper left Y
	shl	ecx, 16
	add	ecx, login_win_Y; Size
	; fn 0.edx - window colour and type (type 14 - fixed size with title)
	mov	edx, [sc.work]
	or	edx, 0x14000000
	; fn 0.esi - window title style and colour
	mov	esi, [sc.grab]
	or	esi, 0x80000000
	mcall
	; Draw roster tree
	invoke	tl_draw, main_tree
	; End redraw
	mcall	12,2
	; Return
	ret
endp

proc wait_main
	mcall	10
	cmp	eax,1
	je	.redraw

	cmp	eax,2
	je	.key

	cmp	eax,3
	je	.button

	cmp	eax,6
	je	.mouse

	cmp	eax,8
	je	.network

	jmp	.final

     .redraw:
	call	main_win_draw
	jmp	.final

     .key:
	call	main_key
	jmp	.final

     .button:
	call	main_btn_action
	jmp	.final

     .mouse:
	invoke tl_mouse, main_tree
	jmp	.final

     .network:
	call	socket_recieve
	call	main_logic
	jmp	.final

     .final:
	ret
endp

proc main_key
	mcall	2
	invoke tl_key, main_tree
	ret
endp

; Button was pressed
proc main_btn_action
	; Get button number
	mcall	17
	; If id = 1 (red cross) - close program
	cmp	ah, 1
	je	close_progr
	; Wait for next input
	ret
endp

align 4
proc request_roster
	ccall createXmlOpen,xc_iq,'',[snd_buffer],\
		xc_from, x_stream.from,\
		xc_type, xc_iq_type_get,\
		xc_id, xc_session,\
		0
	sub	esp, 0xC

	stdcall strlen,[snd_buffer]
	add	ecx,[snd_buffer]
	ccall createXmlShort,xc_iq,'',ecx,\
		xc_ns, xc_roster_ns,\
		0
	sub	esp, 0xC

	stdcall strlen,[snd_buffer]
	add	ecx,[snd_buffer]
	stdcall createXmlClose,xc_iq,'',ecx

	stdcall strlen,[snd_buffer]
	mov	[msg_len],ecx

	mcall	send, [socketnum], [snd_buffer], [msg_len],0
	ret
endp

;<<<<<<<<<<<<<<<<<<<<<<<<
; LOGIC
;<<<<<<<<<<<<<<<<<<<<<<<<
align 4
proc main_logic
	stdcall cleanbuf,tmp_buffer,1024
	stdcall getXmlNodeName,tmp_buffer,[rcv_buffer]
; Main type for this chain - iq
     .iq:
	stdcall strcmp,xc_iq,tmp_buffer
	test	eax,eax
	jz	.iq_type
	jmp	.msgbox

     .iq_type:
	stdcall getXmlAttrValue,tmp_buffer,[rcv_buffer],xc_type
	stdcall strcmp,xc_result,tmp_buffer
	test	eax,eax
	jz	.iq_type_result
	jmp	.final

     .iq_type_result:
	stdcall findOpenTagClosing,[rcv_buffer],RCVBUFFER,0
	add	ecx,[rcv_buffer]
	inc	ecx
	mov	[msg_len],ecx
	stdcall cleanbuf,tmp_buffer,1024
	stdcall getXmlNodeName,tmp_buffer,[msg_len]

	stdcall strlen,xc_query
	stdcall strstr,[rcv_buffer],RCVBUFFER,xc_query,ecx
	test	eax,eax
	jnz	.iq_query
	jmp	.final

     .iq_query:
	stdcall cleanbuf,tmp_buffer,1024
	add	eax, [rcv_buffer]
	dec	eax
	stdcall getXmlAttrValue,tmp_buffer,eax,xc_ns
	stdcall strcmp,xc_roster_ns,tmp_buffer
	test	eax,eax
	jz	parse_roster
	jmp	.final

; Send message over IPC if fail to parse (maybe msgbox will do)
     .msgbox:
	cmp	[msgbox_pid],0
	je	.final
	mcall	60, 2, DWORD[msgbox_pid], 1, 1
	jmp	.final

     .final:
	ret
endp

align 4
proc parse_roster
	push	edi
	; Init tree list
	stdcall init_tree_list
	; Init user msgbox stack
	stdcall mem.Alloc,1
	mov	[msgbox_usr],eax
	stdcall mem.Alloc,0x1000
	mov	[msgbox_pid],eax
	stdcall mem.Alloc,0x1000
	mov	[msgbox_stack],eax
	stdcall mem.Alloc,0x1000
	mov	[msgbox_offset],eax
	; Set first offset
	mov	ebx,[msgbox_usr]
	mov	[eax],ebx
	; Set reading pointer to rcv_buffer
	mov	edi,[rcv_buffer]
     @@:
	; Find next item
	mov	ebx,RCVBUFFER
	add	ebx,[rcv_buffer]
	sub	ebx,edi
	stdcall findXmlOpen,xc_item,edi,ebx
	test	edi,edi
	jz	.end
	; Move pointer to the item position
	stdcall cleanbuf,tmp_buffer,1024
;        add     edi,eax
	; Get JID
    .test:
	stdcall getXmlAttrValue,tmp_buffer,edi,xc_jid
	; Create new XML node
	stdcall dword[tl_node_add],dword tmp_buffer, dword 0, dword main_tree
	; Move pointer forward
	inc	edi
	jmp	@b

     .success:
	call	send_presence

     .end:
	call	main_win_draw
	pop	edi
	ret
endp

align 4
proc send_presence
	stdcall cleanbuf,[snd_buffer],64
	ccall createXmlShort,xc_presence,'',[snd_buffer],\
		0
	sub	esp, 0xC
	stdcall strlen,[snd_buffer]
	mov	[msg_len],ecx

	mcall	send, [socketnum], [snd_buffer], [msg_len],0
	ret

endp

align 4
proc open_chat
	push	ebx ecx edx esi edi
; Set dest user
	stdcall [tl_node_get_data], main_tree
	pop	esi
	; Get the current remote user name table offset as count*4
	mov	edi,DWORD[msgbox_count]
	shl	edi,2
	add	edi,[msgbox_offset]
	; Write 0-term remote user name string
	stdcall strcpy,esi,[edi]
	inc	edi
	mov	[edi],byte 0
	inc	edi
	; Write new offset
	mov	eax,[msgbox_count]
	inc	eax
	shl	eax,2
	add	eax,[msgbox_offset]
	mov	[eax],edi
; Call new chat window
	mov	edx, 0x1000
	imul	edx, [msgbox_count]
	add	edx, [msgbox_stack]
	call	msgbox_start
	mcall	51,1,msgbox_start,edx
	cmp	eax,-1
	je	.final
	; Write new PID
	mov	edi,DWORD[msgbox_count]
	shl	edi,2
	add	edi,[msgbox_pid]
	mov	[edi],eax
	; Inc msgbox_count
	inc	[msgbox_count]
     .final:
	pop	edi esi edx ecx ebx
	ret
endp

;<<<<<<<<<<<<<<<<<<<<<<<<
; GUI
;<<<<<<<<<<<<<<<<<<<<<<<<
align 4
main_tree	tree_list \
		24, \
		500, \
		tl_draw_par_line, \
		16,\
		16,\
		0x8080ff,\
		0x0000ff,\
		0xffffff,\
		10,\
		35,\
		200-16,\
		185,\
		14,\
		4,\
		0,\
		el_focus,\
		wScr,\
		open_chat

; Scrollbar
align 4
wScr:
	.x:
		.size_x 	dw 16
		.start_x	dw 210-16
	.y:
		.size_y 	dw 185
		.start_y	dw 35
	.btn_high	dd 15
	.type		dd 1
	.max_area	dd 100
	.cur_area	dd 30
	.position	dd 0
	.bckg_col	dd 0xeeeeee
	.frnt_col	dd 0xbbddff
	.line_col	dd 0
	.redraw 	dd 0
	.delta		dw 0
	.delta2 	dw 0
	.run_x:
		.r_size_x	dw 0
		.r_start_x	dw 0
	.run_y:
		.r_size_y	dw 0
		.r_start_y	dw 0
	.m_pos		dd 0
	.m_pos_2	dd 0
	.m_keys 	dd 0
	.run_size	dd 0
	.position2	dd 0
	.work_size	dd 0
	.all_redraw	dd 0
	.ar_offset	dd 1

el_focus	dd main_tree

struct FileInfoBlock
	Function	dd ?
	Position	dd ?
	Flags		dd ?
	Count		dd ?
	Buffer		dd ?
			db ?
	FileName	dd ?
ends

align 4
arrow_icon_fn	db 'Tl_sys_16.png',0
arrow_icon	dd ?
node_icon_fn	db 'Tl_nod_16.png',0
node_icon	dd ?
temp_icon	dd ?
run_file_70	FileInfoBlock
; Msgbox tables
msgbox_usr	dd 0
msgbox_pid	dd 0
msgbox_offset	dd 0
msgbox_stack	dd 0
msgbox_count	dd 0