;<<<<<<<<<<<<<<<<<<<<<<<<
; CONSTANTS
;<<<<<<<<<<<<<<<<<<<<<<<<

msgbox_win_X	= 400
msgbox_win_Y	= 400
CP_BUF_SIZE	= 1024
SCROLL_BTN	= 15
HIST_W		= 250
HIST_H		= 250
IPCBUFFER	= 32

;<<<<<<<<<<<<<<<<<<<<<<<<
; GUI FUNCS
;<<<<<<<<<<<<<<<<<<<<<<<<

align 16
proc msgbox_start
	mcall	40, EVM_REDRAW + EVM_KEY + EVM_BUTTON + EVM_MOUSE + EVM_IPC + EVM_STACK
; Init T_Edit
	stdcall [ted_init], msg_hist
; Get process data
	mcall	9,process,-1
; Find username and copy it to local var
	mov	ax, ds
	mov	es, ax
	cld
	mov	eax,[process.pid]
	mov	ecx,[msgbox_count]
	mov	edi,[msgbox_pid]
	repne	scasw
	je	@f
	mcall	-1
     @@:
	dec	edi
	dec	edi
	sub	edi,[msgbox_pid]
	add	edi,[msgbox_offset]
	mov	edi,[edi]
	stdcall strcpy,edi,msgbox_user
; Add init lines into msgbox
	stdcall strlen,msgbox_user
	stdcall [ted_text_add],msg_hist,msgbox_user,ecx,ted_opt_ed_move_cursor
	stdcall [ted_text_add],msg_hist,msg_hist.symbol_new_line,1,ted_opt_ed_move_cursor
	call	msgbox_win_draw
; Init IPC bus
	mcall	60, 1, ipc_buffer, IPCBUFFER
	jmp	wait_msgbox
endp

proc msgbox_win_draw
	; Start redraw
	mcall	12, 1
	; Get sys colours into sys_colors var
	mcall	48,3,msgbox_sc,10*4
	; fn 0 - define and draw window
	mov	eax, 0
	; fn 0.ebx - win X dims = start * 65536 + x_size
	mov	ebx, 100 * 65536 + msgbox_win_X
	; fn 0.ecx - win Y dims = start * 65536 + y_size
	mov	ecx, 100 * 65536 + msgbox_win_Y
	; fn 0.edx - window colour and type (type 14 - fixed size with title)
	mov	edx, [msgbox_sc.work]
	or	edx, 0x14000000
	; Thread stack control
	mov	esi, 0x1000
	shr	esi, 11
	shl	esi, 16
	add	ebx, esi
	add	ecx, esi
	; fn 0.esi - window decor
	mov	esi, [msgbox_sc.grab]
	or	esi, 0x80000000
	mcall

	; Draw stuff
	invoke	ted_draw, msg_hist
	invoke	edit_box_draw, msgtext_box
	call	msgbox_send_btn_draw

	mcall	12, 2
	ret
endp

proc msgbox_send_btn_draw
	; push regs
	pusha
	; fn 8 - draw btn
	mov	eax, 8
	; fn 8.ebx, 8.ecx - position*65536 + size
	mov	ebx, 200*65536 + 50
	mov	ecx, (25+HIST_H+25)*65536 + 20
	; fn 8.edx - flags + id (id = 2)
	mov	edx, 0x00000003
	; fn 8.esi - color
	mov	esi, 0x00555555
	mcall
	; restore regs
	popa
	;return
	ret
endp

wait_msgbox:
	mcall	10
	cmp	eax,1
	je	.redraw

	cmp	eax,2
	je	.key

	cmp	eax,3
	je	.button

	cmp	eax,6
	je	.mouse

	cmp	eax,7 ; IPC
	je	.ipc

	cmp	eax,8
	je	.network
	jmp	.final

     .redraw:
	call	msgbox_win_draw
	jmp	.final

     .key:
	call	msgbox_key
	jmp	.final

     .button:
	mcall	17
	cmp	ah,1
	je	.close
	cmp	ah,3
	je	.send
	jmp	.final

     .mouse:
	invoke	ted_mouse,msg_hist
	jmp	.final

     .ipc:
;        cmp     [ipc_buffer+8], 1
	jmp	 .ipc_read
;        jmp     .ipc.exit

;     .ipc_exit:
;        jmp     .close

     .ipc_read:
	call	msgbox_logic
	stdcall cleanbuf,ipc_buffer,IPCBUFFER
	jmp	.final

     .network:
	call	msgbox_logic
	jmp	.final

     .send:
	call	send_msg
	jmp	.final

     .close:
	mcall	-1

     .final:
	jmp	wait_msgbox

proc msgbox_key
	; Recieve pressed key into eax
	mcall	2
	invoke	edit_box_key, msgtext_box
	; Wait for next input
	ret
endp

;<<<<<<<<<<<<<<<<<<<<<<<<<<
; LOGIC
;<<<<<<<<<<<<<<<<<<<<<<<<<<
proc msgbox_logic
	stdcall cleanbuf,tmp_buffer,1024
	stdcall getXmlNodeName,tmp_buffer,[rcv_buffer]
     .message:
	stdcall strcmp,xc_message,tmp_buffer
	test	eax,eax
	jz	.rcv_msg
	jmp	.final

     .rcv_msg:
	call	rcv_msg
	jmp	.final

     .final:
	ret
endp

proc rcv_msg
; Find if we have <body>
     .msg_body:
	stdcall cleanbuf,tmp_buffer,20
	push	0
	stdcall createXmlOpen,xc_message_body,'',tmp_buffer
	stdcall strlen,[rcv_buffer]
	mov	ebx,ecx
	stdcall strlen,tmp_buffer
	stdcall strstr,[rcv_buffer],ebx,tmp_buffer,ecx
	test	eax,eax
	jnz	.get_msg

	jmp	.final


     .get_msg:
; Find closing </body> tag
	add	eax,[rcv_buffer]
	add	eax,ecx
	mov	[msg_body.begin],eax
	stdcall createXmlClose,xc_message_body,'',tmp_buffer
	stdcall strlen,msg_len
	mov	ebx,ecx
	stdcall strlen,tmp_buffer
	stdcall strstr,[rcv_buffer],ebx,tmp_buffer,ecx
	test	eax,eax
	jz	.final
	add	eax,[rcv_buffer]
	mov	[msg_body.end],eax
; Print message
	stdcall [ted_text_add],msg_hist,msg_hist.symbol_new_line,1,ted_opt_ed_move_cursor
	stdcall [ted_text_add],msg_hist,msg_hist.symbol_new_line,1,ted_opt_ed_move_cursor
	stdcall strlen,msgbox_user
	stdcall [ted_text_add],msg_hist,msgbox_user,ecx,ted_opt_ed_move_cursor
	stdcall [ted_text_add],msg_hist,msg_hist.symbol_new_line,1,ted_opt_ed_move_cursor
	mov	ecx,[msg_body.end]
	sub	ecx,[msg_body.begin]
	stdcall [ted_text_add],msg_hist,[msg_body.begin],ecx,ted_opt_ed_move_cursor
	call	msgbox_win_draw

     .final:
	ret
endp

proc send_msg
	stdcall cleanbuf,[snd_buffer],SNDBUFFER

	push	0
	push	x_stream.lang
	push	xc_lang
	push	msgbox_user
	push	xc_to
	push	xc_type_chat
	push	xc_type
	push	x_stream.from
	push	xc_from
	stdcall createXmlOpen,xc_message,'',[snd_buffer]

	stdcall strlen,[snd_buffer]
	add	ecx,[snd_buffer]
	push	0
	stdcall createXmlOpen,xc_message_body,'',ecx

	stdcall strlen,[snd_buffer]
	add	ecx,[snd_buffer]
	stdcall strcpy,msgtext_text,ecx

	stdcall strlen,[snd_buffer]
	add	ecx,[snd_buffer]
	stdcall createXmlClose,xc_message_body,'',ecx

	stdcall strlen,[snd_buffer]
	add	ecx,[snd_buffer]
	stdcall createXmlClose,xc_message,'',ecx

	stdcall strlen,[snd_buffer]
	mov	[msg_len],ecx

	mcall	send, [socketnum], [snd_buffer], [msg_len],0
; Add message to history
	stdcall [ted_text_add],msg_hist,msg_hist.symbol_new_line,1,ted_opt_ed_move_cursor
	stdcall [ted_text_add],msg_hist,msg_hist.symbol_new_line,1,ted_opt_ed_move_cursor
	stdcall strlen,x_stream.from
	stdcall [ted_text_add],msg_hist,x_stream.from,ecx,ted_opt_ed_move_cursor
	stdcall [ted_text_add],msg_hist,msg_hist.symbol_new_line,1,ted_opt_ed_move_cursor
	stdcall strlen,msgtext_text
	stdcall [ted_text_add],msg_hist,msgtext_text,ecx,ted_opt_ed_move_cursor
	call	msgbox_win_draw

	ret
endp

;<<<<<<<<<<<<<<<<<<<<<<<<<<
; GUI CONST
;<<<<<<<<<<<<<<<<<<<<<<<<<<

msgbox_sc	system_colors

eb_width	= 150
eb_left 	= 25
eb_bg		= 0xffffff
eb_shift	= 0x6f9480
eb_focus	= 0
eb_blur 	= 0xAABBCC
eb_text_col	= 0
eb_tmax 	= 45

;-----------------------------------
msgtext_top	= 25+HIST_H+25
msgtext_text	db '',0
msgtext_end:
	rb 1024
msgtext_box	edit_box	eb_width, eb_left, msgtext_top,\  ; Width, left, top
				eb_bg, eb_shift, eb_focus,\	; bg color, shift color, focus color
				eb_blur, eb_text_col, eb_tmax,\ ; blur color, text color, max text
				msgtext_text, 0, ed_focus,\	  ; text, mouse_var, flags
				msgtext_end - msgtext_text - 1,\    ; size
				msgtext_end - msgtext_text - 1	    ; pos

msg_hist:
	.wnd	BOX 25,25,HIST_W,HIST_H
	.rec	BOX 30,13,7,10
	.drag_m db 0
	.drag_k db 0
	.sel	dd 0,0,0,0
	.seln	dd ?,?,?,?
	.tex		dd 0
	.tex_1		dd 0
	.tex_end	dd 0
	.cur_x		dd 0
	.cur_y		dd 0
	.max_chars	dd 5002
	.count_colors_text	dd 1
	.count_key_words	dd 0
	.color_cursor		dd 0xff0000
	.color_wnd_capt 	dd 0xc0c0c0
	.color_wnd_work 	dd 0xffffff
	.color_wnd_bord 	dd 0x000000
	.color_select		dd 0x0000ff
	.color_cur_text 	dd 0x000000
	.color_wnd_text 	dd 0x000000
	.syntax_file		dd 0
	.syntax_file_size	dd 500
	.text_colors		dd 0
	.help_text_f1		dd 0
	.help_id		dd -1
	.key_words_data 	dd 0
	.tim_ch 	dd ?
	.tim_undo	dd ?
	.tim_ls 	dd ?
	.tim_co 	dd ?
	.el_focus	dd hist_focus
	.err_save	db 0
	.panel_id	db 0
	.key_new	db 0
	.symbol_new_line	db 13
	.scr_w		dd hist_vscroll
	.scr_h		dd hist_hscroll
	.arr_key_pos	dd 0
	.buffer 	dd msg_hist_buffer
	.buffer_find	dd 0
	.cur_ins	db 1
	.mode_color	db 1
	.mode_invis	db 0
	.gp_opt 	db 0
	.fun_on_key_ctrl_o	dd 0
	.fun_on_key_ctrl_f	dd 0
	.fun_on_key_ctrl_n	dd 0
	.fun_on_key_ctrl_s	dd 0
	.buffer_size		dd CP_BUF_SIZE
	.fun_find_err		dd 0
	.fun_init_synt_err	dd 0
	.fun_draw_panel_buttons dd 0
	.fun_draw_panel_find	dd 0
	.fun_draw_panel_syntax	dd 0
	.fun_save_err		dd 0
	.increase_size		dd 225
	.ptr_free_symb		dd ?

; Scrollbar
hist_vscroll:
	.x:
		.size_x 	dw SCROLL_BTN
		.start_x	dw 0
	.y:
		.size_y 	dw SCROLL_BTN
		.start_y	dw 0
	.btn_high	dd SCROLL_BTN
	.type		dd 1
	.max_area	dd 100
	.cur_area	dd 30
	.position	dd 0
	.bckg_col	dd 0xeeeeee
	.frnt_col	dd 0xbbddff
	.line_col	dd 0
	.redraw 	dd 0
	.delta		dw 0
	.delta2 	dw 0
	.run_x:
		.r_size_x	dw 0
		.r_start_x	dw 0
	.run_y:
		.r_size_y	dw 0
		.r_start_y	dw 0
	.m_pos		dd 0
	.m_pos_2	dd 0
	.m_keys 	dd 0
	.run_size	dd 0
	.position2	dd 0
	.work_size	dd 0
	.all_redraw	dd 0
	.ar_offset	dd 1

; Scrollbar
hist_hscroll:
	.x:
		.size_x 	dw SCROLL_BTN
		.start_x	dw 0
	.y:
		.size_y 	dw SCROLL_BTN
		.start_y	dw 0
	.btn_high	dd SCROLL_BTN
	.type		dd 1
	.max_area	dd 100
	.cur_area	dd 30
	.position	dd 0
	.bckg_col	dd 0xeeeeee
	.frnt_col	dd 0xbbddff
	.line_col	dd 0
	.redraw 	dd 0
	.delta		dw 0
	.delta2 	dw 0
	.run_x:
		.r_size_x	dw 0
		.r_start_x	dw 0
	.run_y:
		.r_size_y	dw 0
		.r_start_y	dw 0
	.m_pos		dd 0
	.m_pos_2	dd 0
	.m_keys 	dd 0
	.run_size	dd 0
	.position2	dd 0
	.work_size	dd 0
	.all_redraw	dd 0
	.ar_offset	dd 1


msg_hist_buffer rb CP_BUF_SIZE
hist_focus	dd msg_hist
msgbox_user	rb 256
ipc_buffer	rb IPCBUFFER
msg_body:
	.begin	dd ?
	.end	dd ?
process:
	.cpu	dd 0
	.win	dw 0
	.slot	dw 0
	.none	dw 0
	.name	rb 11
	.none2	db 0
	.addr	dd 0
	.size	dd 0
	.pid	dd 0
	.win_x	dd 0
	.win_y	dd 0
	.win_sx dd 0
	.win_sy dd 0
	.status dw 0
	.none3	dw 0
	.cli_x	dd 0
	.cli_y	dd 0
	.win_w	dd 0
	.win_h	dd 0
	.state	db 0